<!DOCTYPE html>
<html lang="en">
<head>
     <meta charset="UTF-8">
     <meta http-equiv="X-UA-Compatible" content="IE=edge">
     <meta name="viewport" content="width=device-width, initial-scale=1.0">
     <title>Task 32.50</title>

     <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
     <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
     <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

</head>
<body>
     <div class="container">
          <div class="text-center">
               <h2>Danh sách người dùng đăng kí</h2>
          </div>
          <div>
               <button class="btn btn-success" id="btn-add-user">Thêm User</button>
          </div>

          <table class="table table-bordered table-striped table-hover" id="table-user">
               <thead>
                    <tr>
                         <th>Id</th>
                         <th>Firstname</th>
                         <th>Lastname</th>
                         <th>Country</th>
                         <th>Subject</th>
                         <th>Customer Type</th>
                         <th>Register Status</th>
                         <th>Action</th>
                    </tr>
               </thead>
               <tbody></tbody>
          </table>
     </div>
</body>

<script>
      "use strict";
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */

  /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
     $(document).ready(function(){
          onPageLoading();
          
     })
  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
     function onPageLoading(){
          goiAPILayDuLieuUser();
          
     }

     //gắn event headler cho nút sửa 
     $("#table-user").on("click", ".btn-edit", onBtnEditClick);

     //gắn event handler cho nút xóa 
     $("#table-user").on("click", ".btn-delete", onBtnDeleteClick);

     //gắn event handler cho nút thêm user
     $("#btn-add-user").on("click", onBtnAddUserClick);

  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/

  //hàm gọi api để lấy dữ liệu 
  function goiAPILayDuLieuUser(){
     "use strict"
     $.ajax({
          url: "http://203.171.20.210:8080/crud-api/users/",
          type: "GET",
          dataType: "json", 
          success: function(res){
               console.log(res);
               loadUserDataToTable(res);
          }, 
          error: function(ajaxContext){
               alert(ajaxContext.responseText);
          }
     });
  }

  //hàm load dữ liệu lên bảng 
  function loadUserDataToTable(paramUserData){
     for(var bI = 0; bI < paramUserData.length; bI++){
          //tạo row: hàng
          var bNewRow = $("<tr>").appendTo("#table-user");
          //tạo cell: cột 
          $("<td>").html(paramUserData[bI].id).appendTo(bNewRow);
          $("<td>").html(paramUserData[bI].firstname).appendTo(bNewRow);
          $("<td>").html(paramUserData[bI].lastname).appendTo(bNewRow);
          $("<td>").html(paramUserData[bI].country).appendTo(bNewRow);
          $("<td>").html(paramUserData[bI].subject).appendTo(bNewRow);
          $("<td>").html(paramUserData[bI].customerType).appendTo(bNewRow);
          $("<td>").html(paramUserData[bI].registerStatus).appendTo(bNewRow);

          //tạo cột chứa nút sửa và xóa 
          var bAction = $("<td>").appendTo(bNewRow);
          //tạo nút sửa
          var bEditBtn = $("<button>")
               .attr("class", "btn btn-primary col-6 btn-edit")
               .html("Sửa");
          bEditBtn.attr("data-id", paramUserData[bI].id);
          bEditBtn.attr("data-firstname", paramUserData[bI].firstname);
          bEditBtn.attr("data-lastname", paramUserData[bI].lastname);
          bEditBtn.attr("data-country", paramUserData[bI].country);
          bEditBtn.attr("data-subject", paramUserData[bI].subject);
          bEditBtn.attr("data-customerType", paramUserData[bI].customerType);
          bEditBtn.attr("data-registerStatus", paramUserData[bI].registerStatus);

          //thêm vào cột action
          bEditBtn.appendTo(bAction);

          //tạo nút xóa
          var bDeleteBtn = $("<button>")
               .attr("class", "btn btn-danger col-6 btn-delete")
               .html("Xóa");
          bDeleteBtn.attr("data-id", paramUserData[bI].id);
          bDeleteBtn.attr("data-firstname", paramUserData[bI].firstname);
          bDeleteBtn.attr("data-lastname", paramUserData[bI].lastname);
          bDeleteBtn.attr("data-country", paramUserData[bI].country);
          bDeleteBtn.attr("data-subject", paramUserData[bI].subject);
          bDeleteBtn.attr("data-customerType", paramUserData[bI].customerType);
          bDeleteBtn.attr("data-registerStatus", paramUserData[bI].registerStatus);

          //thêm vào cột action
          bDeleteBtn.appendTo(bAction);
     }
  }

  //gán sự kiện cho nút sửa 
  function onBtnEditClick(){
     "use strict"
     console.log("Khi bấm nút sửa, Id của user tương ứng là: " + $(this).data("id"));
     const vDETAIL_FORM_URL = "updateUser.html";
     var vUrlToOpenPage = 
     vDETAIL_FORM_URL + "?" + "id= " + $(this).data("id");
     window.location.href = vUrlToOpenPage;
  }

  //hàm sự kiện cho nút xóa 
  function onBtnDeleteClick(){
     "use strict"
     console.log("Khi bấm nút xóa, Id của user tương ứng là: " + $(this).data("id"));
  }

  //hàm xử lý khi nút thêm user được nhấn 
  function onBtnAddUserClick(){
     "use strict"
     const vDETAIL_FORM_URL = "insertUser.html";
     var vUrlToOpenPage = vDETAIL_FORM_URL;
     window.location.href = vUrlToOpenPage;
  }
</script>
</html>